Attribute VB_Name = "Module1"
Option Explicit

Public Type Particle
    x As Single
    y As Single
    xOld As Single
    yOld As Single
    vx As Single
    vy As Single
    vxOld As Single
    vyOld As Single
End Type

Public Particles() As Particle

Public Sub Init(Optional NumParticles As Long = 99)

Dim i As Long

ReDim Particles(0 To NumParticles)

For i = 0 To UBound(Particles)
    Particles(i).x = Rnd * Form1.Picture1.ScaleWidth
    Particles(i).y = Rnd * Form1.Picture1.ScaleHeight
    Particles(i).xOld = Particles(i).x - 1
    Particles(i).yOld = Particles(i).y - 1
    Particles(i).vx = Particles(i).x - Particles(i).xOld
    Particles(i).vy = Particles(i).y - Particles(i).yOld
    Particles(i).vxOld = Particles(i).vx
    Particles(i).vyOld = Particles(i).vy
Next

Call Draw

End Sub

Public Sub Animate()

Dim i As Long
Dim vx As Single
Dim vy As Single

For i = 0 To UBound(Particles)
    Particles(i).vxOld = Particles(i).vx
    Particles(i).vyOld = Particles(i).vy
    
    'Vernderung der Geschwindigkeit ber die Zeit: Beschleunigung
    Particles(i).vx=Particles(i).vx+
    Particles(i).vy=Particles(i).vy+
    
    Particles(i).xOld = Particles(i).x
    Particles(i).yOld = Particles(i).y
    
    Particles(i).x = Particles(i).x + Particles(i).vx
    Particles(i).y = Particles(i).y + Particles(i).vy

    If Particles(i).x > Form1.Picture1.ScaleWidth Or Particles(i).y > Form1.Picture1.ScaleHeight Or Particles(i).x < 0 Or Particles(i).y < 0 Then
        If Rnd < 0.5 Then
            Particles(i).x = 0
            Particles(i).y = Rnd * Form1.Picture1.ScaleHeight
        Else
            Particles(i).x = Rnd * Form1.Picture1.ScaleWidth
            Particles(i).y = 0
        End If
    
        Particles(i).xOld = Particles(i).x - 1
        Particles(i).yOld = Particles(i).y - 1
    End If
Next

Call Draw

End Sub

Public Sub Draw()

Dim i As Long

Form1.Picture1.Cls

For i = 0 To UBound(Particles)
    Form1.Picture1.PSet (Particles(i).x, Particles(i).y)
Next

End Sub














